
\ =============================================================
\ nRF24L01+ranger.f
\ chu ( vum@eml.ru ) 13:26 21.03.2014

\
\ nRF24L01+.f required
\

\ Product Specification v1.0
\ Appendix C - Constant carrier wave output for testing
\
\ Configuration
\ 1. Set PWR_UP= 1 and PRIM_RX= 0 in the CONFIGregister.
\ 2. Wait 1.5ms PWR_UP->standby.
\ 3. In the RF register set: 
\ - CONT_WAVE= 1.
\ - PLL_LOCK= 1.
\ - RF_PWR.
\ 4. Set the wanted RF channel.
\ 5. Set CEhigh.
\ 6. Keep CEhigh as long as the carrier is needed.
\
\ =============================================================

\ RF_PWR bits
  $0 constant -18dBm
  $2 constant -12dBm
  $4 constant -6dBm
  $6 constant 0dBm
\
\  &4 bit constant pll_lock
\  &7 bit constant cont_wave

  nRF24_RF_SETUP &7 bit &4 bit or bitmask: rf-test
  nRF24_RF_SETUP &2 bit &1 bit or bitmask: rf-pwr

  : carrier+ ( c1 c2 --- )    \ c1==rf_channel, c2==rf_output_power
    radio-pw? 0= if
    radio-on   then
    radio-tx+
    rf-pwr   #set+
    rf-test  #bit+
    radio-ch!
    nRF24_CE high
  \ The nRF24L01+ should now output an unmodulated centered carrier.
    ;

  : carrier-
    nRF24_CE low
    rf-test  #bit- 
    radio-off
    ;

  : rfpw-tst   ( c1 c2 --- )    \ c1==rf_channel, c2==rf_output_power
    carrier+
   ." The nRF24L01+ now output an unmodulated centered carrier." cr
    begin pause key? until key drop
    carrier- ." The output carrier stoped." cr
    ; 

\
\ ====== mobile receiver range led indicator  ===========================

 marker =range-led=

\ m328p
 PORTB 0 portpin: blue
 PORTB 1 portpin: green
 PORTB 2 portpin: red

 : 0led 
   blue  over over pin_output high
   green over over pin_output high
   red   over over pin_output high
   ;

 : b+ blue  low  ;
 : b- blue  high ;
 : g+ green low  ;
 : g- green high ;
 : r+ red   low  ;
 : r- red   high ;

\
\ carrier+ must be executed on transmitter side of the rf channel 
\

  : range-led ( c --- )  \ c==rf channel

    radio-ch! 0led
    radio-pw? 0= if radio-on then

    begin
         radio-rx+
         [ 40 us/ ]
         literal  ?delay \ If no packets are received the RPD is latched
         nRF24_CE low    \ at the end of a receive period as a result
                         \ of host MCU setting CE low (6.4 RPD measurements)
       \ standby-I
         cd? if r- g+ else g- r+ then

    key? until
    key  drop
    0led
    ;
\
\

  : start-ranger   nRF24_init  &13 ( radio-channel ) range-led ;

\
\ ~~~~~~~~~~eof~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\ occupy ? cells